"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.compile = void 0;
var compiler_base_jsx_1 = require("@paperclipui/compiler-base-jsx");
var CODE_PREFLIGHT = "\n\nconst encode = (value) => value.replace(/['<>\\u00A0-\u9999<>\\&]/gim, function(i) {\n  return '&#'+i.charCodeAt(0)+';';\n});\n\nconst flatten = v => v.reduce((ary, v) => {\n  if (Array.isArray(v)) {\n    ary.push(...flatten(v));\n  } else {\n    ary.push(v);\n  }\n  return ary;\n}, []);\n\nconst VOID_TAGS = [\"br\", \"img\", \"hr\"];\n\nconst isVoid = (v) => VOID_TAGS.includes(v);\n\nconst createElement = (tag, attributes, ...children) => {\n  if (typeof tag === \"function\") {\n    return tag({ ...attributes, children });\n  }\n  const buffer = [\"<\" + tag + \"\"];\n\n  for (let key in attributes) {\n    let value = attributes[key];\n    if (key === \"className\") {\n      key = \"class\";\n    }\n    if (key === \"ref\") {\n      continue;\n    }\n    if (key === \"style\") {\n      value = stringifyStyle(value);\n    } else if (typeof value === \"string\") {\n      value = encode(value);\n    }\n    buffer.push(\" \" + key + \"=\\\"\" + value + \"\\\"\");\n  }\n\n  if (isVoid(tag)) {\n    buffer.push(\"/>\");\n    return buffer.join(\"\");\n  }\n\n  buffer.push(\">\");\n\n  buffer.push(flatten(children).filter(v => v !== false && v != null).join(\"\"));\n\n  buffer.push(\"</\" + tag + \">\");\n\n  return buffer.join(\"\");\n}\n\nconst stringifyStyle = (value) => Object.entries(value).map(([key, value]) => (\n  key + \":\" + value\n)).join(\";\");\n\nconst Fragment = (props) => flatten(props.children).join(\"\");\n\nconst _vanilla = {\n  createElement,\n  Fragment,\n  forwardRef: v => v,\n  memo: v => v\n};\n\n".trim();
exports.compile = (0, compiler_base_jsx_1.compilers)({
    code: {
        imports: "import React from \"react\";\n",
        preflight: CODE_PREFLIGHT,
        vendorName: "_vanilla"
    },
    definition: {
        imports: "",
        elementType: "string"
    },
    extensionName: function (targetOptions) {
        return targetOptions.es5 ? "js" : "mjs";
    }
});
